#pragma once

#include "dataspace_interface.h"
#include "flexpage.h"
#include "memory.h"
#include "resource.h"



/* A simple pager exposing a single memory region as a dataspace. */

class SimplePager : public Dataspace, public Resource
{
protected:
    Memory *_memory;
    Region *_region;

public:
    explicit SimplePager(Memory *memory=NULL);

    void close();

    /* Paging methods. */

    long map(offset_t offset, l4_addr_t hot_spot, flags_t flags, l4_snd_fpage_t *region);

    long info(offset_t *size, flags_t *flags);
};

// vim: tabstop=4 expandtab shiftwidth=4
